<template>
  <div>
    <input
      type="text"
      class="todo-input"
      placeholder="Unijeti stvari u listu"
      v-model="NewTodo"
      @keyup.enter="addTodo"
    />
    <h3>Lista pocinje odavde</h3>
    <div v-for="(todo, index) in todos" :key="todo.id" class="todo-for">
      <div
        v-if="!todo.editing"
        @dblclick="editTodo(todo)"
        class="todo-item-label"
      >
        {{ todo.title }}
      </div>
      <input
        v-else
        type="text"
        class="todo-item-edit"
        
        v-model="todo.title"
        @blur="doneEditing(todo)"
        @keyup.enter="doneEditing(todo)"
        v-focus
        @keyup.esc="cancelEditing(todo)"
      />
      <div class="remove">
        <button @click="removeTodo(index)" class="button">x</button>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "todo-list",
  data() {
    return {
      NewTodo: "",
      beforeEditCache: '',
      idForTodo: 3,
      todos: [
        {
          id: 1,
          title: "Pravljenje ToDo liste",
          completed: false,
          editing: false,
        },
        {
          id: 2,
          title: "Proba test",
          completed: false,
          editing: false,
        },
      ],
    };
  },
  directives: {
  focus: {
    inserted: function (el){
      el.focus()
    }
  }
  },
  methods: {
    addTodo() {
      this.todos.push({
        id: this.idForTodo,
        title: this.NewTodo,
        completed: false,
      });
      this.NewTodo = "";
      this.idForTodo++;
    },
    removeTodo(index) {
      this.todos.splice(index, 1);
    },
    editTodo(todo){
      this.beforeEditCache = todo.title
      todo.editing = true

    },
    cancelEditing(todo){
      todo.title = beforeEditCache
      todo.editing = false
    },
    doneEditing(todo){
      todo.editing = false
    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style  >
.todo-input {
  width: 100%;
  padding: 10px 15px;
  margin-bottom: 20px;
  font-size: 18px;
}
.todo-for {
  font-size: 1.5rem;
  width: 100%;
  margin-bottom: 12px;
  display: flex;
  align-items: center;
  justify-content: space-between;
}
.button {
  border: 2px solid black;
  width: 30px;
  height: 20px;
  background-color: azure;
}
.button:hover {
  background-color: bisque;
}
.todo-item-left{
  display: flex;
  align-items: center;
}
.todo-item-label{
  padding: 10px;
  border: 1px solid white;
  margin-left: 12px;
}
.todo-item-edit{
  font-size: 1.5rem;

  color:inherit;
  margin-left: 12px;
  width: 100%;
  padding: 10px;
  border: 1px solid #ccc;

}
</style>
